"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _defineProperty(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function ownKeys(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);t&&(o=o.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,o)}return r}function _objectSpread2(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?ownKeys(r,!0).forEach((function(t){_defineProperty(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):ownKeys(r).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}const RSAA="@@redux-api-middleware/RSAA";function isPlainObject(e){return e&&"object"==typeof e&&Object.getPrototypeOf(e)===Object.prototype}function isRSAA(e){return isPlainObject(e)&&e.hasOwnProperty(RSAA)}function isValidTypeDescriptor(e){const t=["type","payload","meta"];if(!isPlainObject(e))return!1;for(let r in e)if(!~t.indexOf(r))return!1;return"type"in e&&("string"==typeof e.type||"symbol"==typeof e.type)}function validateRSAA(e){var t=[];const r=["endpoint","options","method","body","headers","credentials","bailout","types","fetch","ok"],o=["omit","same-origin","include"];if(!isRSAA(e))return t.push("RSAAs must be plain JavaScript objects with an [RSAA] property"),t;const n=e[RSAA];isPlainObject(n)||t.push("[RSAA] property must be a plain JavaScript object");for(let e in n)~r.indexOf(e)||t.push(`Invalid [RSAA] key: ${e}`);const{endpoint:i,method:a,headers:s,options:p,credentials:c,types:u,bailout:y,fetch:f,ok:d}=n;if(void 0===i?t.push("[RSAA] must have an endpoint property"):"string"!=typeof i&&"function"!=typeof i&&t.push("[RSAA].endpoint property must be a string or a function"),void 0===a?t.push("[RSAA] must have a method property"):"string"!=typeof a?t.push("[RSAA].method property must be a string"):~["GET","HEAD","POST","PUT","PATCH","DELETE","OPTIONS"].indexOf(a.toUpperCase())||t.push(`Invalid [RSAA].method: ${a.toUpperCase()}`),void 0===s||isPlainObject(s)||"function"==typeof s||t.push("[RSAA].headers property must be undefined, a plain JavaScript object, or a function"),void 0===p||isPlainObject(p)||"function"==typeof p||t.push("[RSAA].options property must be undefined, a plain JavaScript object, or a function"),void 0!==c&&("string"!=typeof c?t.push("[RSAA].credentials property must be undefined, or a string"):~o.indexOf(c)||t.push(`Invalid [RSAA].credentials: ${c}`)),void 0!==y&&"boolean"!=typeof y&&"function"!=typeof y&&t.push("[RSAA].bailout property must be undefined, a boolean, or a function"),void 0===u)t.push("[RSAA] must have a types property");else if(Array.isArray(u)&&3===u.length){const[e,r,o]=u;"string"==typeof e||"symbol"==typeof e||isValidTypeDescriptor(e)||t.push("Invalid request type"),"string"==typeof r||"symbol"==typeof r||isValidTypeDescriptor(r)||t.push("Invalid success type"),"string"==typeof o||"symbol"==typeof o||isValidTypeDescriptor(o)||t.push("Invalid failure type")}else t.push("[RSAA].types property must be an array of length 3");return void 0!==f&&"function"!=typeof f&&t.push("[RSAA].fetch property must be a function"),void 0!==d&&"function"!=typeof d&&t.push("[RSAA].ok property must be a function"),t}function isValidRSAA(e){return!validateRSAA(e).length}class InvalidRSAA extends Error{constructor(e){super(),this.name="InvalidRSAA",this.message="Invalid RSAA",this.validationErrors=e}}class InternalError extends Error{constructor(e){super(),this.name="InternalError",this.message=e}}class RequestError extends Error{constructor(e){super(),this.name="RequestError",this.message=e}}class ApiError extends Error{constructor(e,t,r){super(),this.name="ApiError",this.status=e,this.statusText=t,this.response=r,this.message=`${e} - ${t}`}}function _objectSpread(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},o=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(o=o.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),o.forEach((function(t){_defineProperty$1(e,t,r[t])}))}return e}function _defineProperty$1(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}async function getJSON(e){const t=e.headers.get("Content-Type");return!~[204,205].indexOf(e.status)&&t&&~t.indexOf("json")?await e.json():await Promise.resolve()}function normalizeTypeDescriptors(e){let[t,r,o]=e;return"string"!=typeof t&&"symbol"!=typeof t||(t={type:t}),"string"!=typeof r&&"symbol"!=typeof r||(r={type:r}),"string"!=typeof o&&"symbol"!=typeof o||(o={type:o}),[t,r=_objectSpread({payload:(e,t,r)=>getJSON(r)},r),o=_objectSpread({payload:(e,t,r)=>getJSON(r).then(e=>new ApiError(r.status,r.statusText,e))},o)]}async function actionWith(e,t=[]){try{e.payload="function"==typeof e.payload?await e.payload(...t):e.payload}catch(t){e.payload=new InternalError(t.message),e.error=!0}try{e.meta="function"==typeof e.meta?await e.meta(...t):e.meta}catch(t){delete e.meta,e.payload=new InternalError(t.message),e.error=!0}return e}function _objectSpread$1(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},o=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(o=o.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),o.forEach((function(t){_defineProperty$2(e,t,r[t])}))}return e}function _defineProperty$2(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const defaults={ok:e=>e.ok,fetch:fetch};function createMiddleware(e={}){const t=Object.assign({},defaults,e);return({getState:e})=>r=>o=>isRSAA(o)?(async()=>{const n=validateRSAA(o);if(n.length){const e=o[RSAA];if(e.types&&Array.isArray(e.types)){let t=e.types[0];t&&t.type&&(t=t.type),r({type:t,payload:new InvalidRSAA(n),error:!0})}return}const i=o[RSAA];var{endpoint:a,body:s,headers:p,options:c={},fetch:u=t.fetch,ok:y=t.ok}=i;const{method:f,credentials:d,bailout:l,types:A}=i,[b,h,S]=normalizeTypeDescriptors(A);try{if("boolean"==typeof l&&l||"function"==typeof l&&l(e()))return}catch(t){return r(await actionWith(_objectSpread$1({},S,{payload:new RequestError("[RSAA].bailout function failed"),error:!0}),[o,e()]))}if("function"==typeof a)try{a=a(e())}catch(t){return r(await actionWith(_objectSpread$1({},S,{payload:new RequestError("[RSAA].endpoint function failed"),error:!0}),[o,e()]))}if("function"==typeof s)try{s=s(e())}catch(t){return r(await actionWith(_objectSpread$1({},S,{payload:new RequestError("[RSAA].body function failed"),error:!0}),[o,e()]))}if("function"==typeof p)try{p=p(e())}catch(t){return r(await actionWith(_objectSpread$1({},S,{payload:new RequestError("[RSAA].headers function failed"),error:!0}),[o,e()]))}if("function"==typeof c)try{c=c(e())}catch(t){return r(await actionWith(_objectSpread$1({},S,{payload:new RequestError("[RSAA].options function failed"),error:!0}),[o,e()]))}let m,R;"function"==typeof b.payload||"function"==typeof b.meta?r(await actionWith(b,[o,e()])):r(b);try{m=await u(a,_objectSpread$1({},c,{method:f,body:s||void 0,credentials:d,headers:p||{}}))}catch(t){return r(await actionWith(_objectSpread$1({},S,{payload:new RequestError(t.message),error:!0}),[o,e()]))}try{R=y(m)}catch(t){return r(await actionWith(_objectSpread$1({},S,{payload:new InternalError("[RSAA].ok function failed"),error:!0}),[o,e(),m]))}return r(R?await actionWith(h,[o,e(),m]):await actionWith(_objectSpread$1({},S,{error:!0}),[o,e(),m]))})():r(o)}function apiMiddleware({getState:e}){return createMiddleware()({getState:e})}var es=Object.freeze({__proto__:null,RSAA:RSAA,isRSAA:isRSAA,validateRSAA:validateRSAA,isValidRSAA:isValidRSAA,InvalidRSAA:InvalidRSAA,InternalError:InternalError,RequestError:RequestError,ApiError:ApiError,getJSON:getJSON,createMiddleware:createMiddleware,apiMiddleware:apiMiddleware}),RSAA$1=es.RSAA,broker=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{endpoint:"/",types:[],method:"GET",body:{},headers:{},options:{},credentials:{},fetch:{}},t=arguments.length>1&&void 0!==arguments[1]&&arguments[1],r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:function(){},o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:function(e){return e},n=e.types,i=[n[0],{type:n[1],payload:function(e,t,n){return r(e,t,n),n.json().then((function(e){return o(e)}))}},{type:n[2],meta:function(e,t,o){return r(e,t,o),o?{status:o.status,statusText:o.statusText}:{status:"Network request failed"}}}],a=t?e.body:JSON.stringify(e.body);return _defineProperty({},RSAA$1,{endpoint:e.endpoint||"",method:e.method||"GET",types:e.types?i:[],headers:_objectSpread2({},"object"===_typeof(e.headers)?e.headers:{}),body:a})},src=broker;module.exports=src;
